1000 REMark BetterBasic - Renumber and indent SuperBasic program - v 2.20
1010 REMark               Chas Dillon - Apr 86, rev Jun 92 for IBM
1020 :
1030 REMark Sketches to extend to IBM targetted programs
1040 REMark   - allow statement starting with ' as remark
1050 REMark   - allow DEF SEG to be 'non-structure' clause
1060 REMark   - allow DEF FN to be an in-line 'non-structure' clause
1070 REMark   - allow THEN after IF
1080 REMark   - transform IF expr THEN lineno into IF expr THEN GOTO lineno
1090 REMark --- consider terminating the IF if GOTO lineno is followed by ELSE
1100 REMark   - check on GOTO and GOSUB as allowable forms of GO TO, GO SUB
1110 REMark     expand PRINT statements
1120 REMark   -       .. put space between PRINT"  ==> PRINT "
1130 REMark ---       .. put ; separator between unseparated elements
1140 REMark   - NEXT terminates the prior FOR, do not translate to END FOR
1150 REMark   - NEXT may carry multiple arguments e.g. NEXT i,j
1160 REMark   - FOR has no 'in-line' form - it must be terminated with NEXT
1170 REMark   - in-line FOR without an in-line NEXT to be broken over 2+ lines
1180 REMark   - input file may terminate with ^Z - check > 1ch left
1190 REMark   - RUN, SYSTEM are same as GOTO in that statements beyond
1200 REMark     these cmds on the same line can't be reached
1210 :
1220 TURBO_objfil 'win1_Chas_BetterBasic_bin220'
1230 TURBO_taskn  'BBasic v2.20'
1240 TURBO_objdat 20
1250 TURBO_repfil
1260 TURBO_diags 'd' : TURBO_struct 's' : TURBO_optim 'b'
1270 TURBO_windo 0   : TURBO_locstr 'i' : TURBO_model '<'
1280 :
1290 IMPLICITB bad_match, DIM_LOC_or_DATA, directory_device, end_file
1300 IMPLICITB force_write, for_output, found_else, found_some, hold_line, IBM
1310 IMPLICITB Line_Data_Ended, limited, More_Stmts_in_Clause
1320 IMPLICITB Last_Stmt_on_Line_is_Struct
1330 IMPLICITB more_than_one, must_be_number, New_Select_Case
1340 IMPLICITB Non_Executive_Stmt, new_line_pending, pass_two, pre_decrement
1350 IMPLICITB quit, quote_on, REM_Type_Stmt, reformat, reseq, reading
1360 IMPLICITB second_pass_reqd, select_case_start, show_in
1370 IMPLICITB show_out, single_line_struct, space_needed, structure_ended
1380 IMPLICITB structure_end_needed, swapped, Trouble_with_Superch
1390 IMPLICITB type_num, first_char, text_wanted, using_TURBO, valid_end
1400 IMPLICITB escaped
1410 :
1420 IMPLICIT% bad, ii, io_err, jj, key, which_word
1430 IMPLICIT% current_struct_type, start_of_stmt, Structure_on_Line
1440 IMPLICIT% Literal_is_Sliced, debugging
1450 IMPLICIT% Statement_Ends_Structure, Statement_Starts_Structure
1460 :
1470 IMPLICITL base_address, Delimiter, File_Length, free_capacity, x, y, z
1480 IMPLICITL max_lines
1490 :
1500 REMark    extra cmds/fns: DEVICE_STATUS
1510 REMark                    CURSOR_ON, CURSOR_OFF
1520 REMark                    SET_POSITION, POSITION
1530 :
1540 REMark  Programming quite technical ...
1550 REMark    uses SuperBASIC 'dynamic' scoping for many variables
1560 REMark    uses indirect recursion for the two main PROCedures:
1570 REMark        Analyse_Structure   and
1580 REMark        Process_Structure
1590 :
1600 REMark  ip_str$        The input line (line no & leading spaces stripped)
1610 REMark  ip_str_ptr%    Pointer to unprocessed (next) char in ip_str$
1620 REMark  statement$     The current statement being analysed
1630 REMark  stmt_word$     The first (key) word in the current statement
1640 REMark  start_of_word% Pointer to ch in ip_str$ that starts curr. word
1650 REMark  start_of_stmt  Pointer to ch in ip_str$ that starts curr. stmt
1660 :
1670 WHEN ERRor
1680   IF reading
1690     io_err = 1
1700     RETRY
1710     END IF
1720   END WHEN
1730 :
1740 DIM vers$(6)
1750 vers$ = "2.20"
1760 :
1770 IF COMPILED : OPEN #1, 'con'
1780 :
1790 MODE 0 : WINDOW 512,256,0,0 : PAPER 0 : CLS
1800 :
1810 Set_up_Tables
1820 IF NOT quit
1830   Set_up_Options
1840   IF NOT quit
1850     Set_up_Tokens : Copy_Program
1860     DEALLOCATE base_address
1870     END IF
1880   END IF
1890 :
1900 DEFine PROCedure Set_up_Tables
1910 :
1920 MANIFEST : line_bytes% = 6
1930 MANIFEST : avg_line_len% = 25
1940 MANIFEST : max_string_size%  =  300
1950 MANIFEST : max_line_length%  = 1000
1960 MANIFEST : pass_back_length% =  600
1970 MANIFEST : instring_length% =  160
1980 :
1990 DIM ip_str$(max_line_length%)    : REMark Stripped input line
2000 DIM op_line$(max_line_length%)   : REMark Stripped output line
2010 DIM statement$(max_string_size%)
2020 DIM stmt_word$(max_string_size%)
2030 DIM pass_back$(pass_back_length%)
2040 DIM in_indent$(60)               : REMark Leading spaces on input line
2050 DIM out_indent$(60)              : REMark Leading spaces on output line
2060 DIM sel_extra$(60)               : REMark
2070 DIM prior_select_id$(60)         : REMark Name of SELect variable
2080 :
2090 REMark String Constants and Tables
2100 DIM intab$(instring_length%), outtab$(instring_length%)
2110 DIM reseqtab$(instring_length%),troubletab$(instring_length%)
2120 DIM key_local$(6), key_loc$(4), key_then$(6), key_else$(6), key_elseif$(6)
2130 DIM key_rem$(6), key_remark$(6), key_mist$(6), key_mistake$(8), key_apostr$(2)
2140 DIM key_dim$(6), key_data$(6), quote1$(2), quote2$(2), quote_marks$(4)
2150 DIM key_dataarea$(12), key_global$(10), key_external$(12)
2160 DIM key_implicit1$(10), key_implicit2$(10), key_reference$(12)
2170 DIM stmt_delimit$(6), word_delimit$(20)
2180 :
2190 REMark DIM str$(2), txt$(2), dflt$(2), suff$(2)
2200 DIM quote_char$(2)
2210 DIM opdvc$(6), ipfnm$(50), opfnm$(50)
2220 :
2230 REMark  __________________  Figurative constants  ______________________
2240   MANIFEST : TRUE      =   1 : FALSE     =   0
2250   MANIFEST : err_bfn% = 1  : err_fnf% = 2 : err_cof% = 3
2260   MANIFEST : err_msp% = 4  : err_cab% = 5
2270 :
2280   MANIFEST : dbg_word = 1  : dbg_isol = 2 : dbg_next = 4
2290   MANIFEST : dbg_othr = 8
2300 :
2310 REMark ----------------------  Keyboard Constants ------------------------
2320   MANIFEST : SPACE_key =  32 : ENTER_key =  10
2330   MANIFEST : TAB_key   =   9 : CTRL_z    =  26 : F3_key = 240
2340   MANIFEST : ESC_key   =  27 : CTRL_ESC  = 128 : F4_key = 244
2350   MANIFEST : lf_arrow  = 192 : del_lf    = 194 : del_stol = 195
2360   MANIFEST : rt_arrow  = 200 : del_rt    = 202 : del_ndol = 203
2370   MANIFEST : up_arrow  = 208 : dn_arrow  = 216
2380   MANIFEST : underscore=  95
2390   MANIFEST : kbd_txt = 0     : REMark Use with Kbd_Resp calls
2400   MANIFEST : kbd_chr = 1
2410   MANIFEST : kbd_dig = 2
2420   MANIFEST : kbd_num = 3
2430   DIM key_bffr$(20) : key_bffr$ = ""
2440 :
2450   REMark  -------------  Logic Variables  ------------------------------
2460   quote_on = FALSE : debugging = FALSE : quit = FALSE
2470   show_in = FALSE  : show_out = FALSE : text_wanted = FALSE
2480   reformat = FALSE : reseq = FALSE    : second_pass_reqd = FALSE
2490   pass_two = FALSE : new_line_pending = FALSE
2500   pre_decrement = FALSE : using_TURBO = TRUE
2510   select_case_start = FALSE
2520   background_task = FALSE : reading = FALSE : io_err = FALSE
2530 :
2540   REMark  -------------  Variables  ------------------------------------
2550   colr_p% = 2        : colr_n% = 0
2560   colr_d% = 7        : colr_s% = 4
2570   warnings% = 0      : errors% = 0
2580   inset% = 0         : in_step% = 3       : global_inset% = 0
2590   ip_line_no% = 0    : ip_ct% = 0         : op_count% = 0
2600   op_line_no% = 1000 : interval% = 10     : out_length_lim% = 70
2610   op_line$ = ""      : ip_str$ = ""       : ip_str_ptr% = 1
2620   statement$ = ""    : stmt_word$ = ""
2630   sel_extra$ = ""    : sel_indent% = 0    : select_sw% = 0
2640 :
2650   END DEFine
2660 :
2670 DEFine PROCedure Set_up_Tokens
2680   REMark Keywords that increase indent
2690   IF IBM
2700     intab$ = "                                                \IF/        \SELECT/                                        \WHILE/     \DO/        \FOR/       "
2710     ELSE
2720     intab$ = "\DEFine/    \DEF/       \DEFPROC/   \DEFFN/     \IF/        \SELect/    \SEL/       \WHEN/      \WHEN_ERROR/\REPeat/    \REP/       \FOR/       "
2730     END IF
2740   MANIFEST : in_size% = 12
2750   MANIFEST : top_point% = 0
2760   MANIFEST : def_point% = 1
2770   MANIFEST : if_point% = 5
2780   MANIFEST : sel_point% = 6
2790   MANIFEST : when_point% = 8
2800   MANIFEST : rep_point% = 10
2810   MANIFEST : for_point% = 12
2820 :
2830   REMark Keywords that decrease indent
2840   IF IBM
2850     outtab$ = "\END/                            \ENDIF/    \WEND/     \LOOP/                                                            \NEXT/     "
2860     ELSE
2870     outtab$ = "\END/      \ENDDEFine/\ENDDEF/   \ENDIF/    \ENDREPeat/\ENDREP/   \ENDSELect/\ENDSEL/   \ENDWHEN/  \END_WHEN/ \ENDFOR/   \NEXT/     "
2880     END IF
2890   MANIFEST : out_size% = 11
2900   MANIFEST : next_point% = 21
2910 :
2920   REMark Keywords that are a problem for resequence
2930   IF IBM
2940     reseqtab$ = "         \RESTORE/\GOSUB/  \ON/     \GO/     \GOTO/   \RET/    \RETurn/ \NEXT/   \EXIT/   \RUN/    \SYSTEM/ \RESUME/ "
2950     ELSE
2960     reseqtab$ = "\DLINE/  \RESTORE/\GOSUB/  \ON/     \GO/     \GOTO/   \RET/    \RETurn/ \NEXT/   \EXIT/   \RUN/    \SYSTEM/ "
2970     END IF
2980   MANIFEST : reseq_size% = 9
2990   MANIFEST : dlne_point% = 1
3000   MANIFEST : rest_point% = 2
3010   MANIFEST : gosb_point% = 3
3020   MANIFEST : on_point%   = 4
3030   MANIFEST : go_point%   = 5
3040   MANIFEST : goto_point% = 6
3050   MANIFEST : ret_point%  = 7
3060   MANIFEST : retn_point% = 8
3070   MANIFEST : exit_point% = 10
3080   MANIFEST : run_point%  = 11
3090   MANIFEST : syst_point% = 12
3100   MANIFEST : resu_point% = 13
3110 :
3120   REMark Keywords that are a problem for SuperCharge
3130   troubletab$ = "\LIST/ \EDIT/ \RENUM/\AUTO/ \LRUN/ \LOAD/ \MRUN/ \MERGE/\DLINE/"
3140   MANIFEST : trouble_size%  = 7
3150 :
3160   REMark Other significant key words
3170   key_dim$      = "DIM"
3180   key_local$    = "LOCAL"
3190   key_loc$      = "LOC"
3200   key_data$     = "DATA"
3210   key_rem$      = "REM"
3220   key_remark$   = "REMark"
3230   key_apostr$   = "'"
3240   key_mistake$  = "MISTake"
3250   key_mist$     = "MIST"
3260   key_then$     = "THEN"
3270   key_else$     = "ELSE"
3280   key_elseif$   = "ELSEIF"
3290   key_dataarea$ = "DATA_AREA"
3300   key_global$   = "GLOBAL"
3310   key_external$ = "EXTERNAL"
3320   key_implicit1$= "IMPLICIT%"
3330   key_implicit2$= "IMPLICIT$"
3340   key_reference$= "REFERENCE"
3350 :
3360   quote1$       = '"'
3370   quote2$       = "'"
3380   IF IBM
3390     quote_marks$ = quote1$
3400     stmt_delimit$ = ":" & quote2$
3410     ELSE
3420     quote_marks$ = quote1$ & quote2$
3430     stmt_delimit$ = ":"
3440     END IF
3450   word_delimit$ = ": ,;=<>*/+-&|^\#()" & quote1$ & quote2$
3460   END DEFine
3470 :
3480 DEFine PROCedure Copy_Program
3490   OPEN #3,'con__20'
3500   Build_Screen
3510   end_file = FALSE
3520   current_struct_type = top_point%
3530   Analyse_Structure (FALSE)
3540   CLOSE #4 : CLOSE #5
3550   IF (NOT quit) AND second_pass_reqd : Renumber_Program
3560   CLOSE #3
3570   PRINT \\\"BetterBasic - End of task"\\\
3580   ip_str$ = Text_Resp$(1,21,0,"Press ENTER to end: ","")
3590   END DEFine
3600 :
3610 DEFine PROCedure Build_Screen
3620   WINDOW #3,480,26,18,3  : ch_posn% = 52 : BORDER #3,2,7
3630   PAPER #3, colr_p% : INK #3, 0 : CLS #3 : BORDER #3,3
3640   PRINT #3," BetterBasic - v";vers$;" - Apr 92 C.D.";TO 40;"To process: ";File_Length(4);" (Lines  Warn  Errs)"
3650   INK #3,colr_s%
3660   PRINT #3," Press ENTER or TAB or other to toggle/halt";
3670   INK #3,0 : PRINT #3,TO 46;"Read: ";
3680   Print_Fpos : Print_Lnct : Print_Wngs : Print_Errs
3690   PAPER colr_p% : INK 0
3700   WINDOW 480,220,18,29 : CLS
3710   END DEFine
3720 :
3730 DEFine PROCedure Print_Fpos
3740   IF background_task : RETurn
3750   AT #3,1,ch_posn% : PRINT #3, POSITION(#4);
3760   END DEFine
3770 :
3780 DEFine PROCedure Print_Lnct
3790   IF background_task : RETurn
3800   AT #3,1,ch_posn%+8 : PRINT #3, op_count%;
3810   END DEFine
3820 :
3830 DEFine PROCedure Print_Wngs
3840   IF background_task : RETurn
3850   AT #3,1,ch_posn%+15 : PRINT #3, warnings%;
3860   END DEFine
3870 :
3880 DEFine PROCedure Print_Errs
3890   IF background_task : RETurn
3900   AT #3,1,ch_posn%+21 : PRINT #3, errors%;
3910   END DEFine
3920 :
3930 DEFine PROCedure Disp_In(txt$)
3940   IF background_task : RETurn
3950   IF NOT show_in : RETurn
3960   INK colr_d%
3970   PRINT txt$
3980   END DEFine
3990 :
4000 DEFine PROCedure Disp_Out(txt$)
4010   IF background_task : RETurn
4020   IF NOT show_out : RETurn
4030   INK colr_n%
4040   PRINT txt$
4050   END DEFine
4060 :
4070 DEFine PROCedure Analyse_Structure(hold_line)
4080 LOCal ii, lp
4090 LOCal struct_type%, stmt_id$(60), structure_end_needed
4100 LOCal structure_ended, select_tab_pt%, single_line_struct
4110 LOCal found_else
4120 REMark Arrive here with a new structure to expand
4130 REMark statement$ contains structure statement
4140 REMark ip_str$ contains current line
4150 REMark ip_str_ptr% points to end of statement char + 1
4160 REMark ... set up structure description, take care of indents,
4170 REMark     detect in-line, full form structures, nested etc
4180 REMark     output structure statement, call processing routine
4190 REMark     close down structure - if necessary create end statement
4200 REMark     reset indents
4210 :
4220   structure_ended = FALSE : select_tab_pt% = 0
4230   single_line_struct = FALSE : new_line_pending = FALSE
4240   found_else = -1
4250   IF NOT hold_line : Break_Before_Stmt
4260   structure_end_needed = TRUE
4270   ii = current_struct_type
4280   SELect ON ii
4290     = top_point%
4300                struct_type% = top_point% : select_sw% = 0 : inset% = 0
4310                prior_select_id$ = '' : structure_end_needed = FALSE
4320     = def_point% TO def_point%+3
4330                struct_type% = def_point% : select_sw% = 0 : inset% = 0
4340                prior_select_id$ = ''
4350     = if_point%
4360                struct_type% = if_point% : found_else = FALSE
4370     = sel_point% TO sel_point%+1
4380                struct_type% = sel_point% : sel_indent% = 0
4390                select_sw% = select_sw%+1
4400                inset% = global_inset%
4410                select_tab_pt% = inset%
4420                stmt_id$ = Word_from_String$(statement$,2)
4430                IF stmt_id$ == "ON"
4440                  stmt_id$ = Word_from_String$(statement$,3) : END IF
4450                prior_select_id$ = stmt_id$
4460                y% = '=' INSTR statement$
4470                IF y%
4480                  ip_str_ptr% = ip_str_ptr% - LEN(statement$)+y% -1
4490                  REPeat lp : IF ip_str$(ip_str_ptr%) = '=' : EXIT lp : ELSE : ip_str_ptr% = ip_str_ptr% - 1
4500                  statement$ = statement$(1 TO y%-1)
4510                  END IF
4520     = when_point% TO when_point%+1
4530                struct_type% = when_point%
4540     = rep_point% TO rep_point%+1
4550                struct_type% = rep_point%
4560                stmt_id$ = Word_from_String$(statement$, 2)
4570     = for_point%
4580                struct_type% = for_point%
4590                stmt_id$ = Word_from_String$(statement$, 2)
4600     END SELect
4610   Put_to_Output (statement$), (FALSE)
4620   IF struct_type% <> top_point% : Adj_Indent 1
4630   IF Line_Data_Ended((ip_str_ptr%))
4640     REMark ________ No more text after Structure statement ________
4650     Break_After_Stmt
4660     Process_Structure ("")
4670     Clear_Up_Structure
4680     RETurn : END IF
4690   REMark ________ Text on line after Structure statement ________
4700   IF struct_type% < if_point% : Break_After_Stmt
4710   structure_end_needed = FALSE
4720 REMark y% = Tentative_Length%(LEN(ip_str$) - start_of_word%-LEN(statement$)) >= out_length_lim%
4730   y% = Tentative_Length%(LEN(ip_str$) - ip_str_ptr%+1) >= out_length_lim%
4740   IF y% = 0
4750      IF  IBM  OR  NOT using_TURBO
4760         y% = Structure_on_Line((ip_str_ptr%), FALSE)
4770         IF IBM AND y%=0
4780           IF struct_type% = for_point%
4790              REMark Look to find a matching NEXT
4800              y% = NOT Structure_on_Line((ip_str_ptr%), TRUE)
4810              END IF : END IF
4820         ELSE
4830         y% = Last_Stmt_on_Line_is_Struct((ip_str_ptr%))
4840         END IF
4850      END IF
4860   IF y% = 0
4870     IF (struct_type% >= if_point%) AND (struct_type% <> sel_point%)
4880       single_line_struct = TRUE
4890       Process_Structure(ip_str$(ip_str_ptr% TO LEN(ip_str$)))
4900       IF NOT structure_ended : Adj_Indent -1
4910       Break_After_Stmt
4920       ip_str$ = pass_back$ : ip_str_ptr% = 1
4930       RETurn : END IF : END IF
4940   IF y% <> 0
4950     structure_end_needed = TRUE
4960     Put_to_Output "", (TRUE) : reseq = TRUE
4970     ELSE
4980     structure_end_needed = (struct_type% = sel_point%)
4990     Break_After_Stmt : END IF
5000   Process_Structure (ip_str$(ip_str_ptr% TO LEN(ip_str$)))
5010   Break_After_Stmt
5020   Clear_Up_Structure
5030   END DEFine
5040 :
5050 DEFine PROCedure Clear_Up_Structure
5060 LOCal nd$(100)
5070   ip_str$ = pass_back$ : ip_str_ptr% = 1
5080   IF NOT structure_ended AND struct_type% = def_point%
5090     Process_Structure ip_str$ : END IF
5100   ip_str$ = pass_back$ : ip_str_ptr% = 1
5110   IF structure_ended : RETurn
5120   IF structure_end_needed
5130     IF struct_type% = sel_point%
5140       select_sw% = select_sw%-1 : sel_indent% = 0 : END IF
5150     IF pre_decrement : Back_Tab
5160     nd$ = Expected_Struct$
5170     IF text_wanted : nd$ = nd$ & " : rem *^* Added during reformat"
5180     Update_Warnings
5190     Put_to_Output (nd$), (TRUE) : reseq = TRUE
5200     END IF
5210   IF NOT pre_decrement : Back_Tab
5220   END DEFine
5230 :
5240 DEFine PROCedure Back_Tab
5250   IF struct_type% = sel_point%
5260     inset% = select_tab_pt%  : ELSE : Adj_Indent -1 : END IF
5270   END DEFine
5280 :
5290 DEFine FuNction Is_Number(wk$)
5300   IF LEN(wk$) : IF wk$(1) INSTR "0123456789" : RETurn TRUE
5310   RETurn FALSE
5320   END DEFine
5330 :
5340 DEFine PROCedure Process_Structure(str$)
5350 LOCal wk$(30), limited, ip_str_ptr%, current_struct_type, lp
5360   IF struct_type% = sel_point%
5370     prior_select_id$ = stmt_id$ : END IF
5380   ip_str$ = str$
5390   limited = (LEN(ip_str$) <> 0)
5400   ip_str_ptr% = 1
5410   IF IBM
5420     IF struct_type% = if_point%
5430       ip_str$ = Explicit_Goto$(str$,1)
5440       END IF
5450     END IF
5460   REPeat lp
5470     IF quit OR end_file : EXIT lp
5480     IF Line_Data_Ended((ip_str_ptr%))
5490       IF Stripped_Front$(Stripped_Back$(ip_str$)) = ":"
5500       REMark IF ip_str_ptr% = 1 AND NOT limited
5510         REMark Preserve blank line in output - for formatting
5520         Put_to_Output "", (-10)
5530         ELSE
5540         Put_to_Output "", (TRUE)
5550         END IF
5560       IF limited
5570         IF NOT (IBM AND (struct_type% = for_point%)) : EXIT lp
5580         END IF
5590       Get_Next_Line : ip_str_ptr% = 1
5600       NEXT lp
5610       END IF
5620     Isolate_Statement
5630     IF statement$ = "" : NEXT lp
5640     start_of_stmt = start_of_word%
5650     IF Non_Executive_Stmt
5660       NEXT lp : END IF
5670     current_struct_type = Statement_Starts_Structure
5680     IF current_struct_type <> 0
5690       IF current_struct_type < if_point% AND struct_type% <> 0
5700         Put_to_Output "mistake *^* UNEXPECTED DEFine", (TRUE)
5710         Show_Expectation
5720         IF NOT Line_Data_Ended((ip_str_ptr%))
5730           pass_back$ = statement$ & ip_str$(ip_str_ptr% TO LEN(ip_str$))
5740           ELSE : pass_back$ = statement$ : END IF
5750         RETurn : END IF
5760       global_inset% = inset% + sel_indent%
5770       Analyse_Structure (single_line_struct OR select_case_start)
5780       global_inset% = inset% + sel_indent%
5790       NEXT lp : END IF
5800     current_struct_type = Statement_Ends_Structure
5810     IF current_struct_type <> 0
5820       Do_End_Structure
5830       IF valid_end
5840         pass_back$ = ""
5850         IF NOT Line_Data_Ended((ip_str_ptr%))
5860           IF ip_str_ptr% = 0 : ip_str_ptr% = 1
5870           pass_back$ = ip_str$(ip_str_ptr% TO LEN(ip_str$))
5880           END IF
5890         RETurn : END IF
5900       END IF
5910     IF New_Select_Case AND struct_type% <> sel_point%
5920       pass_back$ = statement$ & ip_str$(ip_str_ptr% TO LEN(ip_str$))
5930       RETurn : END IF
5940     y% = Statement_Reqs_Renum% : REMark Response not needed here
5950     IF text_wanted
5960        IF Trouble_with_Superch <> 0
5970           statement$ = statement$ & " : rem *^* Not SuperCHARGEable"
5980           Update_Warnings : END IF
5990        END IF
6000     IF new_line_pending : Break_Before_Stmt : new_line_pending = FALSE
6010     Put_to_Output (statement$), (FALSE)
6020     END REPeat lp
6030   pass_back$ = ""
6040   END DEFine
6050 :
6060 DEFine FuNction Explicit_Goto$(ip_str$, ip_str_ptr%)
6070 LOCal i, incoming%, a$(max_string_size%), b$(max_string_size%), wk$(max_string_size%)
6080 rem For IBM statements of the form
6090 rem                    IF expr THEN lineno ELSE lineno
6100 rem   ... expands 'lineno' to 'GOTO lineno'
6110   incoming% = ip_str_ptr%
6120   wk$ = Stripped_Front$(Next_Word$)
6130   i = 0
6140   IF Is_Number(wk$) : i = "0" & wk$
6150   IF i > 0
6160     IF ' ' INSTR str$ = 1
6170        wk$ = "GOTO"
6180        ELSE
6190        wk$ = "GOTO "
6200        END IF
6210     IF incoming% > 1
6220        a$ = ip_str$(1 to incoming%-1) : ELSE : a$ = ""
6230        endif
6240     IF incoming% <= LEN(ip_str$) and incoming% > 0
6250        b$ = ip_str$(incoming% to LEN(ip_str$)) : ELSE : b$ = ""
6260        endif
6270     return a$ & wk$ & b$
6280     END IF
6290   return ip_str$
6300   END DEFine
6310 :
6320 DEFine FuNction Non_Executive_Stmt
6330   IF REM_Type_Stmt
6340     Put_to_Output (statement$), (TRUE) : ip_str$ = ""
6350     RETurn TRUE : END IF
6360   IF DIM_LOC_or_DATA
6370     IF single_line_struct
6380       Put_to_Output (statement$), (FALSE)
6390       ELSE
6400       Break_Before_Stmt
6410       y% = inset% : inset% = 0
6420       Put_to_Output (statement$), (FALSE) : inset% = y%
6430       Break_After_Stmt : END IF
6440     RETurn TRUE : END IF
6450   IF New_Select_Case
6460     IF struct_type% = sel_point%
6470       sel_indent% = Min_Int%(12, LEN(statement$)+3)
6480       Break_Before_Stmt : END IF
6490     RETurn FALSE : END IF
6500 :
6510   IF reformat AND NOT single_line_struct
6520     IF Tentative_Length%(LEN(statement$)) >= out_length_lim%
6530       Break_Before_Stmt : END IF : END IF
6540 REMark  ______________________________________________ ELSE
6550   IF IBM
6560     IF NOT (stmt_word$ == key_else$)
6570       IF NOT (stmt_word$ == key_elseif$) : RETurn FALSE
6580       END IF
6590     ELSE
6600     IF NOT (stmt_word$ == key_else$) : RETurn FALSE
6610     END IF
6620 :
6630 IF debugging && dbg_othr
6640   PRINT "ELSE>: ";ip_str_ptr%,stmt_word$
6650   PRINT "ELSE>: ";statement$
6660   END IF
6670   IF stmt_word$ == key_elseif$
6680     Post_ELSE_Stmt "elseif"
6690     ELSE
6700     IF NOT (Stripped_Front$(Stripped_Back$((statement$))) = stmt_word$ )
6710       ip_str_ptr% = start_of_stmt + 5 : END IF
6720     IF Structure_on_Line((ip_str_ptr%), FALSE)
6730       Post_ELSE_Stmt "else"
6740       ELSE
6750       IF Tentative_Length%(4) > out_length_lim% : Break_Before_Stmt
6760       IF pre_decrement : Adj_Indent -1
6770       Put_to_Output ("else"), (FALSE)
6780       IF pre_decrement : Adj_Indent 1
6790       IF IBM : ip_str$ = Explicit_Goto$(ip_str$,ip_str_ptr%)
6800       END IF
6810     IF found_else
6820       IF found_else > 0
6830         Put_to_Output "mistake *^* DUPLICATE 'ELSE' STATEMENT", (NOT single_line_struct)
6840         ELSE
6850         Put_to_Output "mistake *^* 'ELSE' STATEMENT NOT EXPECTED", (NOT single_line_struct)
6860         END IF
6870       Update_Errors : END IF
6880     END IF
6890   found_else = (stmt_word$ == key_else$)
6900   RETurn TRUE
6910   END DEFine
6920 :
6930 DEFine PROCedure Post_ELSE_Stmt(e_type$)
6940     IF NOT single_line_struct
6950       Put_to_Output "", (TRUE) : reseq = TRUE
6960       IF pre_decrement : Adj_Indent -1
6970       Put_to_Output (e_type$), (TRUE)
6980       IF pre_decrement : Adj_Indent 1
6990       IF IBM : ip_str$ = Explicit_Goto$(ip_str$,ip_str_ptr%)
7000       ELSE
7010       Put_to_Output (e_type$), (FALSE)
7020       IF IBM : ip_str$ = Explicit_Goto$(ip_str$,ip_str_ptr%)
7030       END IF
7040   END DEFine
7050 :
7060 DEFine FuNction New_Select_Case
7070   IF select_sw% = 0 : RETurn FALSE
7080   IF stmt_word$(1) = "=" : RETurn TRUE
7090   IF NOT (stmt_word$ == "ON") : RETurn FALSE
7100   RETurn (prior_select_id$ == Word_from_String$((statement$),2))
7110   END DEFine
7120 :
7130 DEFine FuNction REM_Type_Stmt
7140   IF stmt_word$ == key_remark$ : RETurn TRUE
7150   IF stmt_word$ == key_rem$ : RETurn TRUE
7160   IF IBM
7170     IF stmt_word$ == key_apostr$ : RETurn TRUE
7180     ELSE
7190     IF stmt_word$ == key_mistake$ : RETurn TRUE
7200     IF stmt_word$ == key_mist$ : RETurn TRUE
7210     END IF
7220   IF stmt_word$ = "" AND Line_Data_Ended((ip_str_ptr%)) : statement$ = ":" : RETurn TRUE
7230   RETurn FALSE
7240   END DEFine
7250 :
7260 DEFine FuNction DIM_LOC_or_DATA
7270   IF stmt_word$ == key_dim$ : RETurn TRUE
7280   IF stmt_word$ == key_data$ : RETurn TRUE
7290   IF IBM : RETurn FALSE
7300   IF stmt_word$ == key_local$ : RETurn TRUE
7310   IF stmt_word$ == key_loc$ : RETurn TRUE
7320   IF NOT using_TURBO : RETurn FALSE
7330   IF stmt_word$ == key_dataarea$ : RETurn TRUE
7340   IF stmt_word$ == key_global$ : RETurn TRUE
7350   IF stmt_word$ == key_external$ : RETurn TRUE
7360   IF stmt_word$ == key_implicit1$ : RETurn TRUE
7370   IF stmt_word$ == key_implicit2$ : RETurn TRUE
7380   IF stmt_word$ == key_reference$ : RETurn TRUE
7390   RETurn FALSE
7400   END DEFine
7410 :
7420 DEFine PROCedure Break_Before_Stmt
7430   IF NOT reformat : RETurn
7440   Put_to_Output "", (TRUE)
7450   IF reseq : RETurn
7460   IF ip_str_ptr% > 1 : reseq = TRUE
7470   END DEFine
7480 :
7490 DEFine PROCedure Break_After_Stmt
7500   IF NOT reformat : RETurn
7510   Put_to_Output "", (TRUE)
7520   IF reseq : RETurn
7530   IF NOT Line_Data_Ended((ip_str_ptr%)) : reseq = TRUE
7540   END DEFine
7550 :
7560 DEFine FuNction Statement_Ends_Structure
7570 LOCal tab_ptr%
7580   tab_ptr% = "\"&stmt_word$&"/" INSTR outtab$
7590   IF tab_ptr% = 0 : RETurn 0
7600   RETurn (tab_ptr% - 1) DIV out_size% + 1
7610   END DEFine
7620 :
7630 DEFine FuNction Statement_Starts_Structure
7640 LOCal tab_ptr%
7650   tab_ptr% = "\"&stmt_word$&"/" INSTR intab$
7660   IF tab_ptr% = 0 : RETurn 0
7670   RETurn (tab_ptr% - 1) DIV in_size% + 1
7680   END DEFine
7690 :
7700 DEFine FuNction Statement_Reqs_Renum%
7710 LOCal ii, bad, word$(max_string_size%)
7720   ii = "\"&stmt_word$&"/" INSTR reseqtab$
7730   IF ii = 0 : RETurn 0
7740   ii = 1 + (ii - 1) DIV reseq_size%
7750   bad = 0
7760   SELect ON ii
7770     = dlne_point%, rest_point%, resu_point%
7780                     IF pass_two
7790                       word$ = Next_Word$
7800                       ELSE
7810                       word$ = Word_from_String$((statement$),2)
7820                       END IF
7830                     IF Is_Number(word$) : bad = 1
7840     = gosb_point%, on_point%  : bad = 1
7850     = go_point%   : IF pass_two
7860                       word$ = Next_Word$
7870                       ELSE
7880                       word$ = Word_from_String$((statement$),2)
7890                       END IF
7900                     IF word$  == "TO" : bad = 2 : ELSE : bad = 1
7910     = goto_point% : bad = 2
7920     = exit_point% : ii = 0
7930                     IF NOT pass_two : Dead_Stmts 'EXIT'
7940     = syst_point% : ii = 0
7950                     IF NOT pass_two : Dead_Stmts 'SYSTEM'
7960     = run_point%  : ii = 0
7970                     IF NOT pass_two : Dead_Stmts 'RUN'
7980     = ret_point%,retn_point%
7990                     ii = 0
8000                     IF NOT pass_two : Dead_Stmts 'RETurn'
8010     END SELect
8020   IF NOT bad : ii = 0 : ELSE : second_pass_reqd = TRUE
8030   IF bad = 2 : IF NOT pass_two : Dead_Stmts "GOTO"
8040   RETurn ii
8050   END DEFine
8060 :
8070 DEFine PROCedure Dead_Stmts(txt$)
8080   IF More_Stmts_in_Clause((ip_str_ptr%))
8090     statement$ = statement$ & " : mistake *^* STATEMENTS AFTER '"&txt$&"' CAN NOT BE REACHED"
8100     Update_Errors : END IF
8110   END DEFine
8120 :
8130 DEFine FuNction More_Stmts_in_Clause(ip_str_ptr%)
8140 REMark *^* Next line probably not needed
8150 LOCal start_of_word%
8160 LOCal statement$(max_string_size%), stmt_word$(max_string_size%)
8170   IF Line_Data_Ended((ip_str_ptr%)) : RETurn FALSE
8180   Isolate_Statement
8190   IF REM_Type_Stmt : RETurn FALSE
8200   IF stmt_word$ == key_else$ : RETurn FALSE
8210   IF Statement_Ends_Structure <> 0 : RETurn FALSE
8220   RETurn TRUE
8230   END DEFine
8240 :
8250 DEFine FuNction Line_Data_Ended(ip_str_ptr%)
8260 LOCal lp
8270   REPeat lp
8280     IF ip_str_ptr% > LEN(ip_str$) : RETurn TRUE
8290     IF (ip_str$(ip_str_ptr%) INSTR " :")=0 : RETurn FALSE
8300     ip_str_ptr% = ip_str_ptr% + 1
8310     END REPeat lp
8320   END DEFine
8330 :
8340 DEFine FuNction Trouble_with_Superch
8350 LOCal tab_ptr%
8360   tab_ptr% = "\"&stmt_word$&"/" INSTR troubletab$
8370   IF tab_ptr% = 0 : RETurn FALSE
8380   RETurn 1 + (tab_ptr% - 1) DIV trouble_size%
8390   END DEFine
8400 :
8410 DEFine FuNction Structure_on_Line(ip_str_ptr%, next_kwd)
8420 REMark *^* Next line probably not needed
8430 LOCal start_of_word%
8440 LOCal statement$(max_string_size%), stmt_word$(max_string_size%), entry_point%
8450   REMark Return 0 if no further structure on line
8460   REMark        +ptr if next statement is a structure
8470   REMark        -ptr if later statement is a structure
8480   entry_point% = ip_str_ptr%
8490   Isolate_Statement
8500   IF next_kwd
8510     IF stmt_word$ == "NEXT" : RETurn ip_str_ptr%
8520     ELSE
8530     IF Statement_Starts_Structure : RETurn ip_str_ptr%
8540     END IF
8550   IF stmt_word$ == key_else$
8560     IF stmt_word$ <> Stripped_Front$(Stripped_Back$((statement$)))
8570       ip_str_ptr% = entry_point% + 5 : END IF
8580       END IF
8590   IF Line_Data_Ended((ip_str_ptr%)) : RETurn 0
8600   RETurn -ABS(Structure_on_Line((ip_str_ptr%), next_kwd))
8610   END DEFine
8620 :
8630 DEFine FuNction Last_Stmt_on_Line_is_Struct(ip_str_ptr%)
8640 LOCal lp, ii, jj
8650   REMark Returns TRUE if last statement on line is a structure statement
8660   REMark Returns FALSE if not
8670   ii = ip_str_ptr%
8680   REPeat lp
8690     jj = Structure_on_Line((ii), FALSE)
8700     IF jj = 0 : RETurn FALSE
8710     ii = ABS(jj)
8720     IF Line_Data_Ended((ii)) : RETurn TRUE
8730     END REPeat lp
8740   END DEFine
8750 :
8760 DEFine PROCedure Do_End_Structure
8770 LOCal ii, bad_match, end_type$(30)
8780   ii = current_struct_type : valid_end = FALSE : bad_match = FALSE
8790   SELect ON ii
8800     = 1   : end_type$ = Word_from_String$((statement$), (2))
8810             Establish_End_Type
8820     = 2,3 : current_struct_type = def_point%
8830     = 4   : current_struct_type = if_point%
8840     = 5,6 : current_struct_type = rep_point%
8850             end_type$ = Word_from_String$((statement$), (2))
8860     = 7,8 : current_struct_type = sel_point%
8870     = 9,10: current_struct_type = when_point%
8880     = 11  : current_struct_type = for_point%
8890             end_type$ = Word_from_String$((statement$), (2))
8900     = 12  : current_struct_type = next_point%
8910 IF debugging && dbg_next
8920    PRINT '>>> FOUND NEXT: '; next_point%, struct_type%, ">";statement$;"<"
8930    END IF
8940             remembered_end% = start_of_stmt
8950             end_type$ = Word_from_String$((statement$), (2))
8960     END SELect
8970   IF current_struct_type = 0
8980     REMark ... END without any qualifier
8990     Put_to_Output (statement$), (FALSE)
9000     IF NOT IBM
9010       Put_to_Output "mistake *^* INCORRECT SYNTAX",(TRUE)
9020       Update_Errors
9030       END IF
9040     statement$ = ""
9050     RETurn : END IF
9060   IF current_struct_type = struct_type%
9070     Check_struct_ID
9080     ELSE
9090     IF current_struct_type = next_point%
9100       IF struct_type% = for_point%
9110         Check_IDs
9120         IF NOT bad_match
9130           IF NOT IBM
9140             statement$ = "endfor " & end_type$
9150             ELSE
9160 IF debugging && dbg_next
9170   PRINT "IBM NEXT:     prior ";ip_str$
9180   END IF
9190             IF end_type$ = ""
9200               statement$ = "next " & stmt_id$
9210               ELSE
9220               IF Line_Data_Ended((remembered_end%))
9230                 statement$ = "next " & end_type$
9240                 ELSE
9250                 IF (end_type$ == statement$(LEN(statement$)-LEN(end_type$)+1 TO LEN(statement$)))
9260                   statement$ = "next " & end_type$
9270                   ELSE
9280                   REMark Multiple FOR variables ...
9290                   statement$ = "NEXT " & end_type$
9300                   ii = end_type$ INSTR ip_str$(remembered_end% TO LEN(ip_str$))
9310                   ii = ii + remembered_end% - 1
9320                   ip_str$(ii TO ii+LEN(end_type$)-1) = FILL$(" ",LEN(end_type$))
9330                   ip_str_ptr% = remembered_end%
9340                   REMark Blank out var name now done, & reposition at NEXT stmt
9350                   END IF : END IF
9360               END IF
9370 IF debugging && dbg_next
9380   PRINT "IBM NEXT: statement ";statement$
9390   PRINT "IBM NEXT:    ip_str ";ip_str$
9400   END IF
9410             END IF
9420           valid_end = TRUE
9430           END IF
9440         bad_match = 0
9450         ELSE
9460         IF struct_type% = rep_point% : Dead_Stmts 'NEXT'
9470         RETurn : END IF
9480       ELSE
9490       IF (current_struct_type = rep_point% OR current_struct_type = for_point%) AND struct_type% = if_point%
9500         statement$ = "next " & end_type$
9510         IF current_struct_type = for_point% : statement$ = statement$ & " : exit " & end_type$
9520         bad_match = 3
9530         ELSE
9540         bad_match = 2 : END IF : END IF
9550     END IF
9560   IF NOT valid_end
9570     IF NOT bad_match : RETurn
9580     Put_to_Output (statement$), (FALSE) : statement$=""
9590     IF bad_match = 2
9600       Put_to_Output "mistake *^* UNMATCHED STRUCTURE TYPES", (TRUE)
9610       Show_Expectation : RETurn : END IF
9620     IF bad_match = 3
9630       Put_to_Output "mistake *^* CHANGED 'END' TO 'NEXT'; MAY NEED 'EXIT' INSTEAD", (TRUE)
9640       Update_Errors : RETurn : END IF
9650     END IF
9660   IF current_struct_type = sel_point%
9670     Break_Before_Stmt
9680     select_sw% = select_sw%-1 : sel_indent% = 0
9690     END IF
9700   IF IBM : IF NOT single_line_struct : Break_Before_Stmt
9710   IF pre_decrement : Back_Tab
9720   Put_to_Output (statement$), (FALSE)
9730   SELect ON current_struct_type
9740      = sel_point% : Break_After_Stmt
9750                     inset% = select_tab_pt%
9760      = REMAINDER
9770          SELect ON current_struct_type
9780             = 1          : Break_After_Stmt
9790             = rep_point% : Break_After_Stmt
9800             END SELect
9810          IF NOT pre_decrement : Back_Tab
9820      END SELect
9830   IF bad_match
9840     Put_to_Output "mistake *^* UNMATCHED STRUCTURE IDENTIFIERS", (TRUE)
9850     Show_Expectation : END IF
9860   structure_ended = TRUE : new_line_pending = TRUE
9870   END DEFine
9880 :
9890 DEFine PROCedure Establish_End_Type
9900   current_struct_type = top_point%
9910   IF end_type$ == "DEFine" : current_struct_type = def_point%  : RETurn
9920   IF end_type$ == "DEF"    : current_struct_type = def_point%  : RETurn
9930   IF end_type$ == "IF"     : current_struct_type = if_point%   : RETurn
9940   IF end_type$ == "SELect" : current_struct_type = sel_point%  : RETurn
9950   IF end_type$ == "SEL"    : current_struct_type = sel_point%  : RETurn
9960   IF end_type$ == "WHEN"   : current_struct_type = when_point% : RETurn
9970   IF end_type$ == "REPeat"
9980     current_struct_type = rep_point%
9990     end_type$ = Word_from_String$((statement$), (3))
10000     RETurn : END IF
10010   IF end_type$ == "REP"
10020     current_struct_type = rep_point%
10030     end_type$ = Word_from_String$((statement$), (3))
10040     RETurn : END IF
10050   IF end_type$ == "FOR"
10060     current_struct_type = for_point%
10070     end_type$ = Word_from_String$((statement$), (3))
10080     RETurn : END IF
10090   END DEFine
10100 :
10110 DEFine PROCedure Check_struct_ID
10120   valid_end = TRUE
10130   IF current_struct_type = def_point%
10140     IF reformat : Break_Before_Stmt
10150     RETurn : END IF
10160   IF current_struct_type = if_point%  : RETurn
10170   IF current_struct_type = sel_point% : RETurn
10180   IF current_struct_type = when_point% : RETurn
10190   Check_IDs
10200   END DEFine
10210 :
10220 DEFine PROCedure Check_IDs
10230   IF IBM : IF struct_type% = for_point% : IF end_type$ = "" : RETurn
10240   IF stmt_id$ == end_type$ : RETurn
10250   bad_match = 1
10260   END DEFine
10270 :
10280 DEFine PROCedure Show_Expectation
10290   Put_to_Output "rem *^* Expected: '" & Expected_Struct$ & "'", (TRUE)
10300   Update_Errors
10310   END DEFine
10320 :
10330 DEFine PROCedure Update_Errors
10340   errors% = errors% + 1 : Print_Errs
10350   reseq = TRUE
10360   END DEFine
10370 :
10380 DEFine PROCedure Update_Warnings
10390   warnings% = warnings% + 1 : Print_Wngs
10400   END DEFine
10410 :
10420 DEFine FuNction Expected_Struct$
10430 LOCal ii, wk$(60)
10440   ii = struct_type%
10450   SELect ON ii
10460     = 0           : wk$ = "no structure terminator"
10470     = 1           : wk$ = "enddef"
10480     = if_point%   : wk$ = "endif"
10490     = sel_point%  : wk$ = "endsel"
10500     = when_point% : wk$ = "endwhen"
10510     = rep_point%  : wk$ = "endrep " & stmt_id$
10520     = for_point%  : wk$ = "endfor " & stmt_id$
10530     END SELect
10540   RETurn wk$
10550   END DEFine
10560 :
10570 DEFine PROCedure Adj_Indent (sgn%)
10580   inset% = Max_Int%(inset% + sgn% * in_step%, 0)
10590   END DEFine
10600 :
10610 DEFine FuNction Tentative_Length%(xtra%)
10620 LOCal ii
10630   ii = 1 + 2*reformat
10640   RETurn LEN(op_line$)+xtra%+ii + (LEN(sel_extra$)+inset%-ii)*(LEN(op_line$)=0)
10650   END DEFine
10660 :
10670 DEFine PROCedure Put_to_Output(str$, force_write)
10680 LOCal ii, wk$(6)
10690   select_case_start = FALSE
10700   IF LEN(str$) <> 0
10710     IF reformat
10720       wk$ = " : "
10730       ELSE
10740       wk$ = ":" : END IF
10750     ii = LEN(op_line$)
10760     IF ii <> 0
10770       IF (IBM AND (struct_type% = if_point%))
10780         IF ii > 4
10790           IF op_line$(ii-3 TO ii) == "THEN"
10800             wk$ = " "
10810             END IF : END IF : END IF
10820       op_line$ = op_line$ & wk$ & str$
10830       ELSE
10840       out_indent$ = FILL$(" ",inset%)
10850       sel_extra$ = ""
10860       IF select_sw% <> 0
10870         select_case_start = New_Select_Case AND (struct_type% = sel_point%)
10880         IF NOT select_case_start : sel_extra$ = FILL$(" ",sel_indent%)
10890         END IF
10900       op_line$ = str$ : END IF : END IF
10910 REMark IF debugging
10920 REMark    INK colr_s% : PAPER colr_s% XOR 7
10930 REMark    PRINT 'Stats: ';inset%,select_tab_pt%,sel_indent%,LEN(sel_extra$)
10940 REMark    PAPER colr_p%
10950 REMark    END IF
10960   IF force_write
10970     IF LEN(op_line$) = 0
10980       IF force_write < -1
10990         op_line$ = op_line_no% & " :"
11000         END IF
11010       ELSE
11020       IF reformat
11030         op_line$ = op_line_no%& " "& out_indent$& sel_extra$& op_line$
11040         ELSE
11050         op_line$ = op_line_no% & in_indent$ & op_line$
11060         END IF : END IF
11070     IF LEN(op_line$) <> 0
11080       PRINT #5,op_line$
11090       Disp_Out op_line$
11100       op_line$ = "" : op_count% = op_count%+ 1 : Print_Lnct
11110       op_line_no% = op_line_no% + interval%
11120       END IF : END IF
11130   END DEFine
11140 :
11150 DEFine PROCedure Isolate_Statement
11160 LOCal ii, stmt_start%, stmt_end%, sliced_literal%, slice_end%
11170 REMark On entry, ip_str_ptr% = 1 ch past stmt terminator of prior stmt
11180 REMark On exit, statement$ holds statement
11190 REMark          stmt_word$ holds 1st word of statement
11200 REMark          start_of_stmt points to start of stmt in ip_str$
11210 REMark          ip_str_ptr% points to 1 past end of stmt in ip_str$
11220 IF debugging && dbg_isol
11230   stmt_word$ = ""
11240   IF ip_str_ptr% > 0
11250     IF LEN(ip_str$)<> 0
11260       stmt_word$ = ip_str$(ip_str_ptr% TO LEN(ip_str$))
11270       END IF : END IF
11280   PRINT "Isolate: ";ip_str_ptr%;" >";stmt_word$
11290   END IF
11300   stmt_start% = ip_str_ptr% : sliced_literal% = 0
11310   stmt_word$ = Stripped_Back$(Next_Word$)
11320   IF Line_Data_Ended((ip_str_ptr%))
11330     IF stmt_start% = ip_str_ptr%
11340       statement$ = "" : ELSE : statement$ = stmt_word$ : END IF
11350     ip_str_ptr% = LEN(ip_str$)+1
11360     ELSE
11370     stmt_end%  = End_Stmt_Ptr%
11380     REMark stmt_end% points to terminator (i.e. : or eol)
11390     IF (stmt_end% - stmt_start%) > max_string_size%
11400       Put_to_Output "mistake *^* Following statement too long", (TRUE)
11410       Put_to_Output "rem *^* " & ip_str$(stmt_start%+max_string_size% TO stmt_end%-1), (TRUE)
11420       Update_Errors : END IF
11430     IF sliced_literal% <> 0
11440       statement$ = ip_str$(stmt_start% TO sliced_literal%-1) & "RFMT_temp$" & ip_str$(slice_end%+1 TO stmt_end%-1)
11450       Put_to_Output "RFMT_temp$ = " & ip_str$(sliced_literal% TO slice_end%), (TRUE)
11460       IF text_wanted : Put_to_Output "rem *^* Added during reformat", (TRUE)
11470       reseq = TRUE : Update_Warnings
11480       ELSE
11490       IF stmt_start% = stmt_end%
11500         statement$ = "" : ELSE
11510         statement$ = ip_str$(stmt_start% TO stmt_end%-1) : END IF
11520       END IF
11530     IF reformat
11540       statement$ = Stripped_Front$(Stripped_Back$((statement$)))
11550       IF LEN(statement$)
11560         ii = LEN(stmt_word$)
11570         IF 0 = (statement$(ii+1) INSTR " =(")
11580           REMark Put a space after a key word (like PRINT, OPEN etc)
11590           statement$ = statement$(1 TO ii) & " " & statement$(ii+1 TO LEN(statement$))
11600           END IF
11610         END IF
11620       END IF
11630     IF quote_on
11640       statement$ = statement$ & quote_char$ & " : rem *^* Missing quote inserted"
11650       Update_Warnings
11660       END IF
11670     ip_str_ptr% = stmt_end% + 1
11680     REMark ip_str_ptr% now points to 1st char of next stmt
11690     END IF
11700   start_of_word% = stmt_start%
11710   END DEFine
11720 :
11730 DEFine FuNction Next_Word$
11740 LOCal word$(max_string_size%), first_char, type_num, slicer%, lp
11750 LOCal wk$(2)
11760   quote_on = FALSE : quote_char$ = ""
11770   REPeat lp
11780     IF ip_str_ptr% > LEN(ip_str$) : RETurn ""
11790     word$ = ip_str$(ip_str_ptr%)
11800     REMark If incoming points to end of stmt, then exit with null
11810     IF (word$ INSTR stmt_delimit$) = 1 : RETurn ""
11820     IF word$ INSTR quote_marks$
11830       quote_on = TRUE : quote_char$ = word$
11840       EXIT lp : END IF
11850     IF word$ = '=' : EXIT lp
11860     IF IBM AND word$ = quote2$
11870       REMark Start of remark in IBM Basic
11880       start_of_word% = ip_str_ptr%
11890       ip_str_ptr% = ip_str_ptr% + 1
11900       RETurn quote2$
11910       END IF
11920     IF 0 = ( word$ INSTR word_delimit$) : EXIT lp
11930     ip_str_ptr% = ip_str_ptr% + 1
11940     END REPeat lp
11950   start_of_word% = ip_str_ptr%
11960   first_char = TRUE
11970   REPeat lp
11980     ip_str_ptr% = ip_str_ptr% + 1
11990     IF ip_str_ptr% > LEN(ip_str$) : first_char = 0 : EXIT lp
12000     wk$ = ip_str$(ip_str_ptr%)
12010     IF quote_on
12020       IF wk$ <> quote_char$ : NEXT lp
12030       quote_on = FALSE
12040       IF NOT pass_two
12050         slicer% = Literal_is_Sliced((ip_str_ptr%))
12060         IF slicer% <> 0
12070           IF sliced_literal% = 0
12080             sliced_literal% = start_of_word%
12090             slice_end% = slicer% : END IF : END IF : END IF
12100       ip_str_ptr% = ip_str_ptr% + 1
12110       first_char = 0 : EXIT lp : END IF
12120     IF first_char
12130        type_num = (word$ INSTR "0123456789") <> 0
12140        IF NOT type_num
12150           IF word$ = "=" OR word$ = "-" OR word$ = "."
12160              type_num = (wk$ INSTR "0123456789") <> 0
12170              END IF : END IF
12180        first_char = FALSE
12190        END IF
12200     IF wk$ INSTR word_delimit$ : EXIT lp
12210     IF NOT type_num : NEXT lp
12220     slicer% = wk$ INSTR "e.0123456789 "
12230     IF slicer% = 0 : first_char=TRUE : EXIT lp
12240     IF slicer% <> 1 : NEXT lp
12250     IF (Next_Char$ INSTR "0123456789") = 0 : first_char=TRUE : EXIT lp
12260     END REPeat lp
12270   IF (ip_str_ptr% - start_of_word%) > max_string_size%
12280     Put_to_Output "mistake *^* Word in following statement too long", (TRUE)
12290     Put_to_Output "rem *^* " & ip_str$(start_of_word%+max_string_size% TO ip_str_ptr%-1), (TRUE)
12300     Update_Errors : END IF
12310   IF first_char : wk$ = ' ' : ELSE : wk$ = ''
12320   word$ = ip_str$(start_of_word% TO ip_str_ptr%-1) & wk$
12330   IF first_char : ip_str$ = ip_str$( 1 TO ip_str_ptr%-1)&' '&ip_str$(ip_str_ptr% TO LEN(ip_str$))
12340   IF debugging && dbg_word
12350     IF NOT background_task
12360        INK colr_s% : PAPER colr_s% XOR 7
12370        PRINT ">";word$;"<"TO 35;inset%,quote_on,ip_str_ptr%,LEN(ip_str$)
12380        PAPER colr_p%
12390        END IF : END IF
12400   RETurn word$
12410   END DEFine
12420 :
12430 DEFine FuNction Next_Char$
12440 LOCal ii
12450   ii = ip_str_ptr% + 1
12460   IF ii > LEN(ip_str$) : RETurn CHR$(255)
12470   RETurn ip_str$(ii)
12480   END DEFine
12490 :
12500 DEFine FuNction Literal_is_Sliced(ip_str_ptr%)
12510 LOCal lp
12520   IF using_TURBO : RETurn FALSE
12530   REPeat lp
12540     ip_str_ptr% = ip_str_ptr% + 1
12550     IF ip_str_ptr% > LEN(ip_str$) : RETurn FALSE
12560     IF ip_str$(ip_str_ptr%) = " " : NEXT lp
12570     IF ip_str$(ip_str_ptr%) <> "(": RETurn FALSE
12580     RETurn ip_str_ptr%-1
12590     END REPeat lp
12600   END DEFine
12610 :
12620 DEFine FuNction Delimiter(txt$)
12630   IF ip_str_ptr% > LEN(ip_str$) : RETurn TRUE
12640   IF quote_on
12650     IF ip_str$(ip_str_ptr%) = quote_char$ : quote_char$ = ""
12660     IF quote_char$ = ""
12670       quote_on = FALSE
12680       IF ip_str_ptr% <> LEN(ip_str$)
12690         slicer% = Literal_is_Sliced((ip_str_ptr%))
12700         IF slicer% <> 0
12710           IF sliced_literal% = 0
12720             sliced_literal% = literal_start%
12730             slice_end% = slicer% : END IF : END IF
12740         END IF : END IF
12750     RETurn FALSE : END IF
12760   IF ip_str$(ip_str_ptr%) INSTR quote_marks$
12770     quote_char$ = ip_str$(ip_str_ptr%)
12780     literal_start% = ip_str_ptr%
12790     quote_on = TRUE : RETurn FALSE : END IF
12800   RETurn (ip_str$(ip_str_ptr%) INSTR txt$) <> 0
12810   END DEFine
12820 :
12830 DEFine FuNction End_Stmt_Ptr%
12840   IF REM_Type_Stmt : RETurn LEN(ip_str$)+1
12850   IF (ip_str$(ip_str_ptr%) INSTR stmt_delimit$) <> 0 : RETurn ip_str_ptr%
12860   Get_End_of_Statement
12870   RETurn ip_str_ptr%
12880   END DEFine
12890 :
12900 DEFine PROCedure Get_End_of_Statement
12910 LOCal literal_start%, lp
12920   REMark On entry, ip_str_ptr% points to 1st unprocessed char
12930   REMark On exit, ip_str_ptr% points to the stmt terminator char
12940   literal_start% = 0
12950   quote_on = FALSE : quote_char$ = ""
12960   REMark IF step_ptr : ip_str_ptr% = ip_str_ptr% + LEN(stmt_word$)
12970   IF ip_str_ptr% < LEN(ip_str$)
12980     quote_on = ip_str$(ip_str_ptr%) INSTR quote_marks$
12990     IF quote_on : quote_char$ = ip_str$(ip_str_ptr%)
13000     END IF
13010   IF stmt_word$ == "IF" : Get_End_of_IF : RETurn
13020   REPeat lp
13030     IF Delimiter((stmt_delimit$)) : EXIT lp
13040     IF NOT IBM
13050       ip_str_ptr% = ip_str_ptr% + 1
13060       ELSE
13070       IF Next_Word$ == key_else$
13080         IF ip_str_ptr% <= LEN(ip_str$)
13090           ip_str$(start_of_word%+4) = ":"
13100           END IF
13110         IF start_of_word% > 1
13120           ip_str$(start_of_word%-1) = ":"
13130           ip_str_ptr% = start_of_word%-1
13140           END IF
13150         END IF
13160       END IF
13170     END REPeat lp
13180   END DEFine
13190 :
13200 DEFine PROCedure Get_End_of_IF
13210 REMark *^* Next line probably not needed
13220 LOCal start_of_word%
13230 LOCal lp
13240   REPeat lp
13250     IF Delimiter((stmt_delimit$)) : EXIT lp
13260     IF Next_Word$ == key_then$
13270       IF IBM : EXIT lp
13280       IF Line_Data_Ended((ip_str_ptr%))
13290         ip_str$(start_of_word% TO start_of_word%+3) = "    "
13300         ip_str_ptr% = LEN(ip_str$) + 1
13310         EXIT lp : END IF
13320       IF reformat
13330         ip_str$(start_of_word% TO start_of_word%+3) = "   :"
13340         ip_str_ptr% = start_of_word% + 3 : END IF
13350       EXIT lp : END IF
13360     END REPeat lp
13370   END DEFine
13380 :
13390 DEFine FuNction Stripped_Back$(txt$)
13400 LOCal ii
13410   FOR ii = LEN(txt$) TO 1 STEP -1
13420     IF txt$(ii) <> " " : RETurn txt$(1 TO ii)
13430     END FOR ii
13440   RETurn ""
13450   END DEFine
13460 :
13470 DEFine FuNction Stripped_Front$(txt$)
13480 LOCal ii
13490   FOR ii = 1 TO LEN(txt$)
13500     IF txt$(ii) <> " " : RETurn txt$(ii TO LEN(txt$))
13510     END FOR ii
13520   RETurn ""
13530   END DEFine
13540 :
13550 DEFine PROCedure Get_Next_Line
13560 LOCal ptr%, key, t%, lp
13570   IF Keybd_Active
13580     key = CODE(Key_from_Kbd$(1))
13590     SELect ON key
13600       = ESC_key   :
13610                     debugging = Debug_Flags(Text_Resp$(1,21,0,"Flags as +/- flg: ","+"))
13620                     Check_Back
13630       = TAB_key   : show_in = NOT show_in : Check_Back
13640       = ENTER_key : show_out = NOT show_out : Check_Back
13650       = F4_key    : Build_Screen : Check_Back
13660       = F3_key    : background_task = TRUE
13670       = REMAINDER : IF key <> 0
13680                       Check_Back
13690                       INK colr_n%
13700                       quit = ("y" == Text_Resp$(1,21,0,"Terminate now (n/y): ","n"))
13710                       PRINT
13720                       IF quit : RETurn
13730                       END IF
13740       END SELect
13750     END IF
13760   IF EOF(#4) : end_file = TRUE : RETurn
13770   reading = TRUE
13780   INPUT #4,ip_str$
13790   RETRY_HERE
13800   reading = FALSE
13810   REMark - Guard against last line without CR/LF
13820   IF io_err
13830     io_err = FALSE : end_file = TRUE
13840     RETurn : END IF
13850   IF LEN(ip_str$)<>0
13860     IF ip_str$(LEN(ip_str$)) = CHR$(13)
13870       IF LEN(ip_str$) = 1
13880         ip_str$ = ""
13890         ELSE
13900         ip_str$ = ip_str$(1 TO LEN(ip_str$)-1)
13910         END IF : END IF : END IF
13920   IF NOT pass_two : Disp_In ip_str$
13930   Print_Fpos
13940   ptr% = 0
13950   REPeat lp
13960     ptr% = ptr% + 1 : IF ptr% > LEN(ip_str$) : EXIT lp
13970     IF 0 = (ip_str$(ptr%) INSTR ("0123456789 ")) : EXIT lp
13980     END REPeat lp
13990   t% = "0" & ip_str$
14000   IF t% <= ip_line_no% : reseq = TRUE
14010   ip_line_no% = t%
14020   IF NOT reformat
14030     t% = ptr% - LEN(ip_line_no%) - 1
14040     IF t% < 1 : t% = 0
14050     in_indent$ = FILL$(" ",t%) : END IF
14060   IF ptr% > LEN(ip_str$)
14070     ip_str$ = "" : ELSE : ip_str$ = ip_str$(ptr% TO LEN(ip_str$))
14080     END IF
14090   IF pass_two : RETurn
14100   IF ip_line_no% = 0 : RETurn
14110   IF NOT reseq : op_line_no% = ip_line_no%
14120   IF ip_ct% > max_lines
14130     IF reseq AND ip_ct%=max_lines+1
14140       Update_Errors
14150       Put_to_Output 'mistake *^* GOTO / GOSUB addressing beyond this line will not be adjusted', FALSE
14160       PRINT '>>>>>>>>>>>>>>>  Line control table full  <<<<<<<<<<<<<'
14170       END IF
14180     ip_ct% = ip_ct% + 1
14190     RETurn : END IF
14200   POKE_W base_address+line_bytes%*ip_ct%, ip_line_no%
14210   POKE_W base_address+line_bytes%*ip_ct%+2, op_line_no%
14220   POKE_W base_address+line_bytes%*ip_ct%+4, 0
14230   ip_ct% = ip_ct% + 1
14240   END DEFine
14250 :
14260 DEFine PROCedure Check_Back
14270   i = background_task
14280   background_task = FALSE
14290   IF i
14300      Print_Fpos
14310      Print_Lnct
14320      Print_Wngs
14330      Print_Errs
14340      END IF
14350   END DEFine
14360 :
14370 DEFine FuNction Word_from_String$(ip_str$, ct%)
14380 REMark *^* Next line probably not needed
14390 LOCal start_of_word%
14400 LOCal ii, ip_str_ptr%, word$(max_string_size%)
14410   ip_str_ptr% = 1
14420   FOR ii=1 TO ct%
14430     word$ = Next_Word$
14440     REMark don't allow scan past end of given string
14450     IF word$ = "" : RETurn ""
14460     END FOR ii
14470   RETurn word$
14480   END DEFine
14490 :
14500 DEFine PROCedure Set_up_Options
14510 LOCal dvc$(5), colr_p%, colr_n%, colr_d%, lp
14520   REPeat outer
14530     CLOSE #4 : CLOSE #5
14540     WINDOW 480,220,18,6
14550     colr_p% = 0 : colr_n% = 4 : colr_d% = 7
14560     PAPER colr_p% : INK colr_n% : CLS
14570     PRINT "BetterBasic - Renumber and/or Reformat SuperBasic program source - C.D. Apr 86"
14580     ipfnm$ = File_Name$(4,"input ","","_bas",2)
14590     IF escaped : quit = TRUE : RETurn
14600     max_lines = 300 + File_Length(4) * line_bytes% / avg_line_len%
14610     IF PEEK_L(SYS_VARS+16) - PEEK_L(SYS_VARS+12) < max_lines
14620       PRINT \\"Insufficient memory available"
14630       quit = TRUE : CLOSE #4 : RETurn : END IF
14640     opfnm$ = File_Name$(5,"output",ipfnm$,"_rnm",5)
14650     IF escaped : NEXT outer
14660     opdvc$ = dvc$
14670     show_in = 'y' == Kbd_Resp$(1,10,10,"Do you want input  list   (y/n): ","y",kbd_chr,-2,1,'yn')
14680     IF escaped : NEXT outer
14690     show_out = 'y'== Kbd_Resp$(1,11,10,"Do you want output list   (y/n): ","y",kbd_chr,-2,1,'yn')
14700     IF escaped : NEXT outer
14710     reseq = 'y'== Kbd_Resp$(1,12,10,"Do you want to resequence (y/n): ","y",kbd_chr,-2,1,'yn')
14720     IF escaped : NEXT outer
14730     IF reseq
14740       REPeat lp
14750         dvc$ = Text_Resp$(1,13,10,"  Enter start line no: ",op_line_no%)
14760         IF escaped : NEXT outer
14770         IF LEN(dvc$) : op_line_no% = "0" & dvc$
14780         dvc$ = Text_Resp$(1,14,10,"  Enter line interval: ",interval%)
14790         IF escaped : NEXT outer
14800         IF LEN(dvc$)
14810           IF dvc$(1) = "-"
14820             IF LEN(dvc$) > 2
14830               debugging = Debug_Flags(dvc$(2 TO LEN(dvc$)))
14840               END IF
14850             dvc$ = "10"
14860             END IF
14870           interval% = "0" & dvc$ : END IF
14880         IF (  op_line_no% + interval% * max_lines / 4 - 50) > 32767
14890           PRINT \\"Invalid line no/interval combination"
14900           ELSE : CLS 2 : EXIT lp : END IF
14910         END REPeat lp
14920       END IF
14930     reformat = 'y'== Kbd_Resp$(1,15,10,"Do you want to reformat   (y/n): ","y",kbd_chr,-2,1,'yn')
14940     IF escaped : NEXT outer
14950     IF reformat
14960       dvc$ = Text_Resp$(1,16,10,"Enter max line length: ",out_length_lim%)
14970       IF escaped : NEXT outer
14980       IF LEN(dvc$) : out_length_lim% = "0" & dvc$
14990 :
15000       dvc$ = Text_Resp$(1,17,10,"   Enter indent width: ",in_step%)
15010       IF escaped : NEXT outer
15020       IF LEN(dvc$) : in_step% = "0" & dvc$
15030       END IF
15040     text_wanted = 'y'== Kbd_Resp$(1,18,8,"Add warning text to program (n/y): ","n",kbd_chr,-2,1,'ny')
15050     IF escaped : NEXT outer
15060     pre_decrement = 'y' == Kbd_Resp$(1,19,3,"ELSE/END IF in same column as IF (n/y): ","n",kbd_chr,-2,1,'yn')
15070     IF escaped : NEXT outer
15080     using_TURBO = 1-('y' == Kbd_Resp$(1,20,7,"Intending to use Supercharge (n/y): ","n",kbd_chr,-2,1,'yn'))
15090     IF escaped : NEXT outer
15100     IBM = ('y' == Kbd_Resp$(1,21,17,"IBM GWBASIC source (y/n): ","y",kbd_chr,-2,1,'yn'))
15110     IF NOT escaped : EXIT outer
15120     END REPeat outer
15130   base_address = ALLOCATION((max_lines))
15140   max_lines = INT (max_lines /  line_bytes%)
15150   END DEFine
15160 :
15170 DEFine FuNction Debug_Flags(txt$)
15180 LOCal ii, jj, kk, lp
15190   ii = 1
15200   kk = debugging
15210   REPeat lp
15220     IF ii+1 > LEN(txt$) : EXIT lp
15230     jj = txt$(ii+1) INSTR "niwo"
15240     IF txt$(ii) = "+"
15250       SELect ON jj
15260         = 1 : kk = kk || dbg_next
15270         = 2 : kk = kk || dbg_isol
15280         = 3 : kk = kk || dbg_word
15290         = 4 : kk = kk || dbg_othr
15300         END SELect
15310       ELSE
15320       SELect ON jj
15330         = 1 : kk = kk &&  ~~dbg_next
15340         = 2 : kk = kk &&  ~~dbg_isol
15350         = 3 : kk = kk &&  ~~dbg_word
15360         = 4 : kk = kk &&  ~~dbg_othr
15370         END SELect
15380       END IF
15390     ii = ii + 2
15400     END REPeat lp
15410 PRINT ,kk
15420   RETurn kk
15430   END DEFine
15440 :
15450 DEFine FuNction File_Name$(chn%,txt$,dflt$,suff$,lin%)
15460 LOCal fnm$(36), wk$(2), z%, dvno%, lp
15470   REPeat lp
15480     wk$ = Kbd_Resp$(1,lin%,0,"  Enter "&txt$&" device type  (f/m/k/r/w/o): ","w",kbd_chr,-1,1,"wfmkro")
15490     IF escaped : RETurn ""
15500     z% = wk$ INSTR "owrkmf"
15510     IF z% = 0 : z% = 6
15520     IF z% = 1
15530       dvc$ = Text_Resp$(1,lin%,22,'identifier         : ',"")
15540       IF escaped : RETurn ""
15550       ELSE
15560       z% = (z%-2)*3 + 1
15570       dvc$ = "winramfdkmdvflp" (z% TO z%+2)
15580       PRINT dvc$
15590       INK colr_n%
15600       dvno% = '0' & Kbd_Resp$(1,lin%+1,4,"Enter "&txt$&" device number    (1 - 6): ","1",kbd_chr,-2,1,'213456')
15610       IF escaped : RETurn ""
15620       dvc$ = dvc$ & dvno% & "_"
15630       END IF
15640     fnm$ = Text_Resp$(1,lin%+2,0,"    Enter "&txt$&" file name ("&suff$&" assumed): ",dflt$)
15650     IF escaped : RETurn ""
15660     IF NOT LEN(fnm$) : fnm$ = dflt$ : PRINT fnm$;
15670     PRINT
15680     IF txt$(1) = "i"
15690       z% = File_not_Available%((chn%),(dvc$&fnm$&suff$), 0, 0,lin%+3)
15700       ELSE
15710       z% = File_not_Available%((chn%),(dvc$&fnm$&suff$), 1, (File_Length(4)), lin%+3)
15720       END IF
15730     IF z% = 0 : PRINT \\: CLS 3 : EXIT lp
15740     PRINT \"Can not open file ";dvc$;fnm$;suff$;
15750     IF z% = err_msp% : PRINT " - insufficient space";
15760     PRINT
15770     END REPeat lp
15780   RETurn fnm$
15790   END DEFine
15800 :
15810 DEFine FuNction File_Length(chn%)
15820 LOCal x, y
15830   y = POSITION(#(chn%))
15840   SET_POSITION #(chn%), 999999 : x = POSITION(#(chn%))
15850   SET_POSITION #(chn%), y
15860   RETurn x
15870   END DEFine
15880 :
15890 DEFine PROCedure Renumber_Program
15900 LOCal ii, problems$(60), pending$(max_line_length%), lp
15910   REMark DELETE (opdvc$&opfnm$&"_rnmwrk")
15920   REMark RENAME (opdvc$&opfnm$&"_rnm"), (opdvc$&opfnm$&"_rnmwrk")
15930   REMark ii = file_not_available%(4, (opdvc$&opfnm$&"_rnmwrk"), 0, 0)
15940   ii = File_not_Available%(4, (opdvc$&opfnm$&"_rnm"), 0, 0,21)
15950   REPeat lp
15960     ii = File_not_Available%(5, (opdvc$&opfnm$&"_rfm"), 1, (File_Length(4)),21)
15970     IF ii = 0 : EXIT lp
15980     IF ii <> err_cab%
15990       problems$ = Text_Resp$(1,21,0,"Create more space on "&opdvc$&" - press ENTER ","")
16000       IF escaped : RETurn
16010       ELSE
16020       problems$ = Text_Resp$(1,21,0,"Rename "&opdvc$&opfnm$&"_rfm - press ENTER ","")
16030       IF escaped : RETurn
16040       END IF
16050     END REPeat lp
16060   show_in = TRUE : show_out = TRUE
16070   pass_two = TRUE : end_file = FALSE : reformat = FALSE
16080   Build_Screen
16090   PRINT \\"SECOND PASS - Renumber phase"\\
16100   REPeat lp
16110     Get_Next_Line
16120     IF quit OR end_file : EXIT lp
16130     Renumber_Line
16140     PRINT #5, ip_line_no%;in_indent$;ip_str$
16150     END REPeat lp
16160   Append_Table
16170   CLOSE #4
16180   CLOSE #5
16190   DELETE (opdvc$&opfnm$&"_rnm")
16200   END DEFine
16210 :
16220 DEFine PROCedure Renumber_Line
16230 LOCal ip_str_ptr%, ii, jj, found_some, swapped, lp
16240   ip_str_ptr% = 1 : quote_on = FALSE : quote_char$ = ""
16250   found_some =  FALSE : problems$ = ""
16260   REPeat lp
16270     IF ip_str_ptr% > LEN(ip_str$) : EXIT lp
16280     stmt_word$ = Next_Word$
16290     IF LEN(stmt_word$)=0 : ip_str_ptr%=ip_str_ptr%+1 : NEXT lp
16300     IF REM_Type_Stmt : EXIT lp
16310     ii = Statement_Reqs_Renum%
16320     IF ii = 0 : Get_End_of_Statement : NEXT lp
16330     IF NOT found_some
16340       IF show_in : pending$ = ip_str$
16350       END IF
16360     swapped = FALSE
16370     SELect ON ii
16380       = dlne_point% : Swap_Number (TRUE), (FALSE), (FALSE)
16390       = rest_point% : Swap_Number (FALSE), (FALSE), (FALSE)
16400       = go_point%   : stmt_word$ = Next_Word$
16410                       Swap_Number (TRUE), (FALSE), (stmt_word$=="SUB")
16420       = goto_point% : Swap_Number (TRUE), (FALSE), (FALSE)
16430       = gosb_point% : Swap_Number (TRUE), (FALSE), (TRUE)
16440       = on_point%   : jj = ON_Type
16450                       SELect ON jj
16460                         = 1 : Swap_Number (TRUE), (TRUE), (TRUE)
16470                         = 2 : Swap_Number (TRUE), (TRUE), (FALSE)
16480                         END SELect
16490       END SELect
16500     IF NOT swapped
16510       Get_End_of_Statement
16520       ELSE
16530       IF NOT found_some
16540         Disp_In ip_line_no% & in_indent$ & pending$
16550         found_some = TRUE : END IF : END IF
16560     END REPeat lp
16570   IF LEN(problems$) <> 0
16580     ip_str$ = ip_str$ & " : mistake *^* Line number not found: " & problems$
16590     END IF
16600   IF found_some
16610     Disp_Out ip_line_no% & in_indent$ & ip_str$ : END IF
16620   END DEFine
16630 :
16640 DEFine FuNction ON_Type
16650 LOCal lp
16660   REMark In SuperBASIC, the ON expr must be varname, but on IBM ...
16670   IF NOT IBM
16680     stmt_word$ = Next_Word$ : stmt_word$ = Next_Word$
16690     IF stmt_word$ == "GO"
16700       stmt_word$ = Next_Word$
16710       IF stmt_word$=="SUB" : RETurn 1 : ELSE : RETurn 2
16720       END IF
16730     IF stmt_word$ == "GOTO" : RETurn 2
16740     IF stmt_word$ == "GOSUB" : RETurn 1
16750     RETurn 0
16760     END IF
16770   REPeat lp
16780     stmt_word$ = Next_Word$
16790     IF stmt_word$ = "" : RETurn 0
16800     IF stmt_word$ == "GO"
16810       stmt_word$ = Next_Word$
16820       IF stmt_word$=="SUB" : RETurn 1 : ELSE : RETurn 2
16830       END IF
16840     IF stmt_word$ == "GOSUB" : RETurn 1
16850     IF stmt_word$ == "GOTO" : RETurn 2
16860     END REPeat lp
16870   END DEFine
16880 :
16890 DEFine PROCedure Swap_Number (must_be_number, more_than_one, subr_ref)
16900 LOCal ii, jj, a$(max_string_size%), b$(max_string_size%), y$(8),lp
16910   REPeat lp
16920     stmt_word$ = Next_Word$
16930     IF LEN(stmt_word$)=0 : EXIT lp
16940     swapped = TRUE
16950     ii = "0" & stmt_word$
16960     IF ii = 0 : jj = 0 : ELSE : jj = New_Line_No%((ii),subr_ref)
16970     IF jj < 1
16980       Update_Errors
16990       IF LEN(problems$)
17000         problems$ = problems$ & ", " & stmt_word$
17010         ELSE : problems$ = ii : END IF
17020       jj = -jj : END IF
17030     IF jj <> 0
17040       y$ = jj
17050       IF start_of_word% < 2
17060         a$ = "" : ELSE : a$ = ip_str$(1 TO start_of_word%-1) : END IF
17070       IF ip_str_ptr% >= LEN(ip_str$)
17080         b$ = "" : ELSE : b$ = ip_str$(ip_str_ptr% TO LEN(ip_str$)) : END IF
17090       ip_str$ = a$ & y$ & b$
17100       ip_str_ptr% = start_of_word% + LEN(y$)
17110       END IF
17120     IF NOT more_than_one : EXIT lp
17130     END REPeat lp
17140   END DEFine
17150 :
17160 DEFine FuNction New_Line_No% (old_line%, subr_ref)
17170 LOCal ctr%, y%, z, nl%, zpt%, lp
17180   ctr% = 0 : y% = 0 : z = 99999
17190   IF old_line% = 0 : RETurn y%
17200   REPeat lp
17210     ctr% = ctr% + 1 : IF ctr% > ip_ct% : EXIT lp
17220     nl% = PEEK_W(base_address+line_bytes%*(ctr%-1))
17230     IF old_line% > nl% : NEXT lp
17240     IF old_line% = nl%
17250       y% = PEEK_W(base_address+line_bytes%*(ctr%-1)+2)
17260       zpt% = ctr%
17270       EXIT lp : END IF
17280     IF z > nl% : z = nl% : zpt% = ctr%
17290     END REPeat lp
17300   IF y% = 0 AND z <> 99999
17310     y% = -PEEK_W(base_address+line_bytes%*(zpt%-1)+2)
17320     END IF
17330   z = base_address+line_bytes%*(zpt%-1)+4
17340   IF subr_ref : z = z + 1
17350   POKE z, 1 : REMark Flag as GOTO/GOSUB target
17360   RETurn y%
17370   END DEFine
17380 :
17390 DEFine PROCedure Append_Table
17400 LOCal ii, jj, z, lin%, wk$(20)
17410   lin% = ip_line_no%+1
17420   jj = 0
17430   PRINT #5;lin%;" REMark .. Lines as targets for GOSUB"
17440   FOR ii = 1 TO ip_ct%
17450     z = base_address + line_bytes% * (ii-1)
17460     IF PEEK(z+5) <> 0
17470       IF jj = 0 : lin% = lin% + 1 : PRINT #5; lin%;" REMark ";
17480       wk$ = PEEK_W(z+2)
17490       PRINT #5;FILL$(" ",7-LEN(wk$));wk$; : jj = jj + 1
17500       IF jj = 10 : PRINT #5 : jj = 0
17510       END IF
17520     END FOR ii
17530   IF jj<>0 : PRINT #5
17540   lin% = lin% + 1
17550   jj = 0
17560   PRINT #5;lin%;" REMark .. Lines as targets for GOTO, RESTORE, etc"
17570   FOR ii = 1 TO ip_ct%
17580     z = base_address + line_bytes% * (ii-1)
17590     IF PEEK(z+4) <> 0
17600       IF jj = 0 : lin% = lin% + 1 : PRINT #5; lin%;" REMark ";
17610       wk$ = PEEK_W(z+2)
17620       PRINT #5;FILL$(" ",7-LEN(wk$));wk$; : jj = jj + 1
17630       IF jj = 10 : PRINT #5 : jj = 0
17640       END IF
17650     END FOR ii
17660   IF jj<>0 : PRINT #5 : lin% = lin% + 1
17670   END DEFine
17680 :
17690 DEFine FuNction File_not_Available% (chn%, txt$, for_output, space_needed,lin%)
17700 LOCal x, ii, free_capacity, yn$(2)
17710   IF LEN(txt$) = 0 OR LEN(txt$) > 36 : RETurn err_bfn%
17720   IF NOT for_output
17730     IF "neto" INSTR txt$ = 1 : RETurn err_bfn%
17740     ELSE
17750     IF "neti" INSTR txt$ = 1 : RETurn err_bfn%
17760     END IF
17770   directory_device = TRUE
17780   IF for_output : ii = 2 : ELSE : ii = 1
17790   x = DEVICE_STATUS((ii), (txt$))
17800   IF x = 65535 * 512 : directory_device = FALSE
17810   IF NOT for_output
17820     IF x >= 0
17830       OPEN_IN #(chn%), (txt$) : RETurn FALSE
17840       ELSE : RETurn err_fnf% : END IF
17850     END IF
17860   IF x = -8
17870     yn$ = Kbd_Resp$(1,lin%,0,"Overwrite "&txt$&" (n/y): ","n",kbd_chr,-2,1,"ny")
17880     IF escaped OR yn$ == "n" : RETurn err_cab%
17890     free_capacity = DEVICE_STATUS(0, (txt$))
17900     IF free_capacity < 0 : RETurn err_cof%
17910     OPEN_IN #chn%, txt$
17920     free_capacity = free_capacity + File_Length((chn%))
17930     CLOSE #chn%
17940     ELSE
17950     IF x < 0 : RETurn err_cof%
17960     free_capacity = x
17970     END IF
17980   IF free_capacity < space_needed : RETurn err_msp%
17990   IF x = -8 : DELETE (txt$)
18000   OPEN_NEW #(chn%), (txt$)
18010   RETurn FALSE
18020   END DEFine
18030 :
18040 DEFine FuNction Within(a,b,c)
18050   RETurn a>=b AND a<=c
18060   END DEFine
18070 :
18080 DEFine FuNction Max_Int%(a%, b%)
18090   IF a% > b% : RETurn a% : ELSE : RETurn b%
18100   END DEFine
18110 :
18120 DEFine FuNction Min_Int%(a%, b%)
18130   IF a% < b% : RETurn a% : ELSE : RETurn b%
18140   END DEFine
18150 :
18160 REMark ----------------------  Keyboard Routines  ------------------------
18170 :
18180 DEFine FuNction ESC_Pressed
18190 LOCal wk$(2)
18200   IF NOT Keybd_Active : RETurn FALSE
18210   wk$ = Key_from_Kbd$(1)
18220   RETurn escaped
18230   END DEFine
18240 :
18250 DEFine FuNction Keybd_Active
18260   IF LEN(key_bffr$) <> 0 : RETurn TRUE
18270   CURSOR_ON #1! : key_bffr$ = INKEY$(#1, 0) : CURSOR_OFF
18280   RETurn LEN(key_bffr$) <> 0
18290   END DEFine
18300 :
18310 DEFine FuNction Key_from_Kbd$(chn)
18320 LOCal wk$(2)
18330   IF LEN(key_bffr$) <> 0
18340     wk$ = key_bffr$ : key_bffr$ = ""
18350     ELSE
18360     CURSOR_ON #chn! : wk$ = INKEY$(#chn, -1) : CURSOR_OFF #chn
18370     END IF
18380   key = CODE(wk$)
18390   escaped = (key = ESC_key)
18400   RETurn wk$
18410   END DEFine
18420 :
18430 DEFine FuNction Kbd_Resp$(chn, lin, col, txt$, dflt$, iptype, min, max, rng$)
18440 LOCal valu, valu$(50)
18450   REPeat kr_lp
18460     IF lin >= 0 : AT #chn, lin, col
18470     INK #chn,colr_n% : PRINT #chn,txt$; : CLS #chn,4
18480     INK #chn,colr_d%
18490     SELect ON iptype
18500       = kbd_txt, kbd_chr
18510           SELect ON iptype
18520             = kbd_txt : valu$ = Text_Resp$(chn, lin, col, dflt$, txt$)
18530             = kbd_chr : valu$ = Key_from_Kbd$(chn)
18540             END SELect
18550                   IF escaped : RETurn dflt$
18560                   IF min > 0 : IF valu$ = '' : Moan : NEXT kr_lp
18570                   IF max <> 0
18580                     IF 0 = (valu$ INSTR rng$)
18590                       IF min >= 0 : Moan : NEXT kr_lp
18600                       valu$ = dflt$
18610                       END IF : END IF
18620                   IF min < -1 : PRINT valu$;
18630                   RETurn valu$
18640       = kbd_dig, kbd_num
18650                SELect ON iptype
18660                  = kbd_dig : valu$ = Key_from_Kbd$(chn)
18670                              IF min < -1 : PRINT valu$;
18680                              valu = '0' & valu$
18690                  = kbd_num : valu$ = Text_Resp$(chn, lin, col, txt$, dflt$)
18700                              valu = Numeric_Resp(valu$)
18710                              IF valu < 0 : Moan : NEXT kr_lp
18720                  END SELect
18730                IF escaped : RETurn dflt$
18740                IF max <> 0 : IF valu < min OR valu > max : Moan : NEXT kr_lp
18750                RETurn valu
18760       END SELect
18770     END REPeat kr_lp
18780   END DEFine
18790 :
18800 DEFine FuNction Numeric_Resp(wk$)
18810 LOCal a, ii, jj
18820   IF wk$='' : RETurn 0
18830   IF wk$(1)<>'$' : RETurn '0' & wk$
18840   IF LEN(wk$) < 2 : RETurn 0
18850   a = 0
18860   FOR ii=2 TO LEN(wk$)
18870     jj=CODE(wk$(ii))
18880     IF jj>=97 : jj=jj-32
18890     IF jj>57 : jj=jj-7
18900     jj = jj - 48
18910     IF NOT Within(jj,0,15) : RETurn -1
18920     a = 16*a + jj
18930     END FOR ii
18940   RETurn a
18950   END DEFine
18960 :
18970 DEFine FuNction Text_Resp$(chn, lin, col, msg$, str$)
18980 LOCal yn$(2), first_press, key, wk$(80), ptr, colbase, lp
18990   wk$ = str$ : first_press = TRUE
19000   AT #chn, lin, col
19010   INK #chn,colr_n% : PRINT #chn,msg$;
19020   INK #chn,colr_d% : PRINT #chn,wk$; : CLS #chn,4
19030   colbase = col + LEN(msg$)
19040   AT #chn,lin, colbase
19050   ptr = 0
19060   REPeat lp
19070     yn$ = Key_from_Kbd$(chn)
19080     SELect ON key
19090       = ENTER_key  : EXIT lp
19100       = ESC_key    : wk$ = str$ : EXIT lp
19110       = up_arrow   : ptr = 0
19120       = dn_arrow   : ptr = LEN(wk$)
19130       = lf_arrow   : IF ptr>0 : ptr = ptr-1
19140       = rt_arrow   : IF ptr<LEN(wk$) : ptr = ptr+1
19150       = del_lf     : IF ptr>0 : ptr=ptr-1 : wk$ = StrMash$(wk$,"",ptr,1)
19160       = del_rt     : wk$ = StrMash$(wk$,"",ptr,1)
19170       = del_stol   : IF ptr
19180                       IF ptr<LEN(wk$)
19190                         wk$ = wk$(ptr+1 TO LEN(wk$)): ptr=0
19200                         ELSE : wk$ = "": ptr = 0 : END IF
19210                         END IF
19220       = del_ndol   : IF ptr<LEN(wk$)
19230                       IF ptr
19240                         wk$ = wk$(1 TO ptr) : ptr = LEN(wk$)
19250                         ELSE : wk$ = "": ptr = 0 : END IF
19260                         END IF
19270       = REMAINDER :  IF first_press : wk$ = ""
19280                      wk$ = StrMash$(wk$,yn$,ptr,0) : ptr = ptr + 1
19290       END SELect
19300     first_press = FALSE
19310     AT #chn,lin, colbase : PRINT #chn,wk$; : CLS #chn,4
19320     AT #chn,lin, colbase+ptr
19330     END REPeat lp
19340   AT #chn, lin, colbase + LEN(wk$)
19350   RETurn wk$
19360   END DEFine
19370 :
19380 DEFine FuNction StrMash$(txt$,b$,ptr,del)
19390 LOCal a$(60), wka$(60)
19400   a$ = txt$
19410   IF del <> 0
19420     IF LEN(a$) = 0 : RETurn a$
19430     IF ptr>=LEN(a$) : RETurn a$
19440     IF LEN(a$)=1
19450       a$ = "" : ELSE
19460       IF ptr = 0
19470         a$= a$(2 TO LEN(a$)) : ELSE
19480         IF ptr+1=LEN(a$) : wka$="" : ELSE : wka$ = a$(ptr+2 TO LEN(a$))
19490         a$ = a$(1 TO ptr) & wka$
19500         END IF : END IF
19510     RETurn a$ : END IF
19520   IF ptr = 0
19530      a$ = b$ & a$ : ELSE
19540   IF ptr >= LEN(a$)
19550      a$ = a$ & b$ : ELSE
19560      a$ = a$(1 TO ptr) & b$ & a$(ptr+1 TO LEN(a$))
19570      END IF : END IF
19580   RETurn a$
19590   END DEFine
19600 :
19610 DEFine PROCedure Moan
19620   BEEP 5000,25,100,100,2
19630   END DEFine
